#include "Dijkstra.h"
#include <vector>
#include <limits>       // std::numeric_limits
#include <queue>        // std::priority_queue
#include <utility>      //std::pair
#include "QueueElement.h"
using namespace std;

typedef priority_queue<QueueElement, 
		       vector<QueueElement>, 
		       ElementComparison> Queue;
typedef pair<long, long> point;

//Utility function for getting the 
//coordinates of all points in the
//4-neighborhood of point (x,y) in "image"
vector<point> Get4Neighbors(long x, long y, CImg<uint8>& image){
  vector<point> neighbors;
  
  if(x-1>=0){
    neighbors.push_back(point(x-1,y));
  }
  
  if(x+1<image.width()){
    neighbors.push_back(point(x+1,y));
  }

   if(y-1>=0){
    neighbors.push_back(point(x,y-1));
  }
  
  if(y+1<image.height()){
    neighbors.push_back(point(x,y+1));
  }

  return neighbors;
}

//Dijkstras algorithm
CImg<double> Dijkstra(CImg<uint8>image, CImg<uint8> seeds){


  //Create a priority queue
  Queue Q;

  //Create an image to store the result
  CImg<double> distances(image.width(), image.height());

  //Initialize all distance values with "infinity"
  double infinity=numeric_limits<double>::max();
  distances.fill(infinity);

  //Push all non-zero elements of "seeds" to the queue
  //and set the corresponding distance values to 0.
  for(long x=0; x<image.width(); x++){
    for(long y=0; y<image.height(); y++){
      if(seeds(x,y)>0){
		Q.push(QueueElement(x,y,0));
		distances(x,y)=0;
      }
    }
  }

  vector<point> neighbors;

  while(!Q.empty()){
    //Get the element with minimum distance
    QueueElement current_element =Q.top();
    
    //Remove that element from the queue
    Q.pop();

    //Process the element ...
    //Implement Dijkstras algorithm here!

    //Use the function "Get4Neighbors" defined above to 
    //retrieve the neighbors of the current point

    //Define the weight of the edge between two neighbors 
    //as the absolute intensity difference between them

  }  

  return distances;
}
