
#define cimg_display 0 //Disable GUI parts of CImg library


#include "CImg/CImg.h"
#include "MSF.h"
#include <iostream>

using namespace cimg_library;
using namespace std;



int main(int argc, char *argv[]){
  if(argc<4){
    cout<<"Example usage: MST image.bmp seeds.bmp labels.bmp"<<endl;
    return 0;
  }
  
  //Load image from file
  CImg<uint8> image(argv[1]);

  //load seed image
  CImg<uint8> seeds(argv[2]);

  //load seed label image
  CImg<uint8> seedlabels(argv[3]);

  //Run Prims algorithm to compute a segmentation where
  //every pixel is given the label of the seed to which it is
  //connected on a MSF relative to the seeds.
  // (You need to implement this function in "MSF.cpp"!)
  CImg<int> segmentation = MSF(image, seeds,seedlabels);

  
  CImg<uint8> output(segmentation.width(), segmentation.height());

  
  for(long x=0; x<image.width(); x++){
    for(long y=0; y<image.height(); y++){
      output(x,y)=uint8(segmentation(x,y));
    }
  }

  //Writing segmentation result to file
  output.save_bmp("result.bmp");

}
