#include <iostream>
#include "graph.h"
using namespace std;

//Graph cut example
//Uses the max-flow implementation from http://vision.csd.uwo.ca/code/

int main(){
	//Use "float" type to store edge weights and flow
	typedef Graph<float,float,float> GraphType;

	//Setup a simple graph with a source, a sink and two additional nodes
	GraphType g = GraphType(/*estimated # of nodes*/ 2, /*estimated # of edges*/ 1);

	g.add_node();
	g.add_node();

	//Set terminal edge weights
	g.add_tweights(0,   /* capacities */  1, 5);
	g.add_tweights(1,   /* capacities */  2.1, 6);
	
	//Set other edge weights
	g.add_edge(0, 1,    /* capacities */  3, 4);

	//Compute maximum flow
	float flow = g.maxflow();

	//Print results 
	cout << "Flow: " << flow << endl;
	if (g.what_segment(0) == GraphType::SOURCE){
		cout << "Node 0 is in the source set." << endl;
	}
	else{
		cout << "Node 0 is in the target set." << endl;
	}

	if (g.what_segment(1) == GraphType::SOURCE){
		cout << "Node 1 is in the source set." << endl;
	}
	else{
		cout << "Node 1 is in the target set." << endl;
	}

	return 0;


}